###############################################################################
#
# itunes_album_playlists.pl
#
# This script will create playlists for every album in your Library
#
# Copyright (C) 2007  Robert Jacobson
# written by: Robert Jacobson (http://mysite.verizon.net/teridon/itunesscripts)
# Last Updated: 28 Jan 2007
# Version 1.0
#
# This script is GPL v2.  see http://www.gnu.org/copyleft/gpl.html
#
###############################################################################

sub itunes_album_playlists {
	
# use File::Basename;
# my $PROGNAME = basename($0);
# my $VERSION = "1.0";
# my $AUTHOR = "Robert Jacobson";
# my $HOMEPAGE = "http://mysite.verizon.net/teridon/";
# my $YEAR = 2007;
# my $GNU_URL = "http://www.gnu.org/copyleft/gpl.html";

# {
# 	print
# 	"**************************************************************\n" .
# 	"$PROGNAME version $VERSION, Copyright (C) $YEAR $AUTHOR\n" .
# 	"Visit $HOMEPAGE for updates\n" . 
# 	"$PROGNAME comes with ABSOLUTELY NO WARRANTY;\n".
# 	"This is free software, and you are welcome\n" .
# 	"to redistribute it under certain conditions\n" .
# 	"for details see $GNU_URL.\n" .
# 	"**************************************************************\n" .
# 	"\n"
# 	;
# }

use strict;
use Win32::OLE;
use Data::Dumper;

## Create the OLE Object
my $iTunes = Win32::OLE->new('iTunes.Application') or die Win32::OLE->LastError();
#$SIG{INT} = \&quit;

my $playlist = $iTunes->LibraryPlaylist();
my $playlist_name = $playlist->Name();

my $tracks = $playlist->Tracks;
my $num_tracks = $tracks->Count();


$| = 1;
print "Getting album & artist information...";

my %seen;
# Get all the tracks in the playlist
for (my $k = 1 ; $k <= $tracks->Count ; $k++ ) {
	#print "num: " , $num_tracks , " Count: ",  $tracks->Count , " k: ", $k , "\n";
	my $track = $tracks->Item($k);
	my $track_kind = $track->Kind();

	if ($track_kind == 1) {
		# File
		#my $songname = $track->Name();
		my $artist = $track->Artist();
		my $album = $track->Album();
		push (@{$seen{$artist}{$album}}, $track);
		#print Dumper @{$seen{$artist}{$album}};
		#my $foo = <STDIN>;
		print ".";
	}
}

for my $artist (sort keys %seen) {
	print OUT "$artist\n---------------\n";
	for my $album ( sort keys %{ $seen{$artist} } ) {
		next if ($album eq "");
		print "Creating playlist for album $album\n";
		#Create a playlist for this album
		my $album_playlist = $iTunes->CreatePlaylist("$album");
		for my $track ( @{$seen{$artist}{$album}} ) {
			$album_playlist->AddTrack($track);
		}
    }
}

print "\nDone\n";
}

1;
