;~ ###############################################################################
;~ #
;~ # itunes_change_showname.pl
;~ #
;~ # This script will change the selected tracks "Show" field to a user-entered value
;~ #
;~ # Copyright (C) 2007  Robert Jacobson
;~ # written by: Robert Jacobson (http://home.comcast.net/~teridon73/itunesscripts)
;~ # Last Updated: 27 Oct 2007
;~ # Version 1.0
;~ #
;~ # This script is GPL v2.  see http://www.gnu.org/copyleft/gpl.html
;~ #
;~ ###############################################################################

$oMyError = ObjEvent("AutoIt.Error","change_showname_error") ; Install a custom error handler

itunes_change_showname()

Func itunes_change_showname ()
		
	;-- Create the OLE Object
	$iTunes = ObjCreate("iTunes.Application")
	
	$tracks = $iTunes.SelectedTracks
	
	$num_tracks = $tracks.Count
	if ($num_tracks < 1) Then
		MsgBox(0, "ERROR", "ERROR: you must select the videos in iTunes first!")
		return False
	EndIf
	
	$showname = InputBox ("Enter Show name" , "Enter the new Show name: ")
	$return = @error
	If ($return = 1) Then
		Return False
	EndIf
	
	; Get all the tracks in the playlist
	for $k = 1 to $num_tracks
		$track = $tracks.Item($k)
		$track_kind = $track.Kind()
		$vidkind = $track.VideoKind
	
		if ($track_kind <> 1 Or $vidkind == 0) Then
			MsgBox(0, "ERROR", "ERROR: track " & $track.Name & " is not a file or video!")
		Else
			$track.Show = $showname
		EndIf
	
	Next
	$iTunes = 0
EndFunc

Func change_showname_error()
	SetError(1)
EndFunc