###############################################################################
#
# itunes_change_showname.pl
#
# This script will change the selected tracks "Show" field to a user-entered value
#
# Copyright (C) 2007  Robert Jacobson
# written by: Robert Jacobson (http://mysite.verizon.net/teridon/itunesscripts)
# Last Updated: 27 Oct 2007
# Version 1.0
#
# This script is GPL v2.  see http://www.gnu.org/copyleft/gpl.html
#
###############################################################################

sub itunes_change_showname {
		
	# use File::Basename;
	# my $PROGNAME = basename($0);
	# my $VERSION = "1.0";
	# my $AUTHOR = "Robert Jacobson";
	# my $HOMEPAGE = "http://mysite.verizon.net/teridon/";
	# my $YEAR = 2007;
	# my $GNU_URL = "http://www.gnu.org/copyleft/gpl.html";
	
	# {
	# 	print
	# 	"**************************************************************\n" .
	# 	"$PROGNAME version $VERSION\n" . 
	# 	"Copyright (C) $YEAR $AUTHOR\n" .
	# 	"Visit $HOMEPAGE for updates\n" . 
	# 	"$PROGNAME comes with ABSOLUTELY NO WARRANTY;\n".
	# 	"This is free software, and you are welcome\n" .
	# 	"to redistribute it under certain conditions\n" .
	# 	"for details see $GNU_URL.\n" .
	# 	"**************************************************************\n" .
	# 	"\n"
	# 	;
	# }
	
	use strict;
	use Win32::OLE;
	
	use Data::Dumper;
	
	# Create a signal handler to destroy the iTunes object
	# in case our program quits before the end
	# use sigtrap 'handler', \&quit, 'normal-signals';
	
	## Create the OLE Object
	my $iTunes = Win32::OLE->new('iTunes.Application') or die Win32::OLE->LastError();
	
	my $tracks = $iTunes->SelectedTracks;
	
	my $num_tracks = $tracks->Count();
	if ($num_tracks < 1) {
		print "ERROR: you must select the videos in iTunes first!\n";
		goto END;
	}
	
	print "Enter the new Show name: ";
	chomp (my $showname = <STDIN>);
	
	# Get all the tracks in the playlist
	for (my $k = 1 ; $k <= $tracks->Count ; $k++ ) {
		#print "num: " , $num_tracks , " Count: ",  $tracks->Count , " k: ", $k , "\n";
		my $track = $tracks->Item($k);
		my $track_kind = $track->Kind();
		my $vidkind = $track->VideoKind;
	
		if ($track_kind != 1 || $vidkind == 0) {
			print "ERROR: track " . $track->Name . " is not a file or video!\n";
		} else {
			$track->LetProperty('Show', $showname);
		}
	
	}

}
END:
1;
