
sub itunes_set_category {
	
use strict;
	use Win32::OLE;
	
	use Data::Dumper;
		
	## Create the OLE Object
	my $iTunes = Win32::OLE->new('iTunes.Application') or die Win32::OLE->LastError();
	
	
	# Get the possible sources
	my $sources = $iTunes->Sources();
	my $sourcesCount = $sources->Count();
	my $source = '';
	my $sourceKind = '';
	
	my $n = 1;
	
	
	# For each source, figure out kind	
	for ($n = 1; $n <= $sourcesCount; $n++) {
		$source = $sources->Item($n);
		$sourceKind = $source->Kind();

		if ($sourceKind == 1) {
			# Get the playlists in the Library
			my $playlists = $source->Playlists();
			my $num_playlists = $playlists->Count();
			print "There are $num_playlists playlists\n";
			
			# For each playlist, show the name and number of tracks
			for (my $j = 1 ; $j <= $num_playlists; $j++) {
				my $playlist = $playlists->Item($j);
				my $playlist_name = $playlist->Name();
				print "\t$j : $playlist_name\n";
			}
			
			print "Enter comma-separated playlist numbers: ";
			chomp (my $nums = <STDIN>);
			my @nums = split(/,/ , $nums);
			for my $i (@nums) {
				my $playlist = $playlists->Item($i);
				my $playlist_name = $playlist->Name();
				print "You selected $playlist_name\n";
				
				my $tracks = $playlist->Tracks;
				my $num_tracks = $tracks->Count();
				print "\t$num_tracks tracks\n";
				
				my %seen;
				# Get all the tracks in the playlist
				for (my $k = $tracks->Count ; $k > 0 ; $k-- ) {
					#print "num: " , $num_tracks , " Count: ",  $tracks->Count , " k: ", $k , "\n";
					my $track = $tracks->Item($k);
					my $track_kind = $track->Kind();
	
					if ($track_kind == 1) {
						# File
						$track->{Category} = "";
					}
	
				}
			}
		}
	}

}

1;

